//+------------------------------------------------------------------+
//|                                                       ADXmod.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen
#property indicator_color2 YellowGreen
#property indicator_color3 Wheat
//---- input parameters
extern int ADXPeriod=14;
extern int DIplusPeriod=14;
extern int DIminusPeriod=14;
extern int Price=0;
extern int DIplusSmooth=1;
extern int DIminusSmooth=1;
extern int ADXSmooth=1;
extern int MAType=1;

//---- buffers
double ADXBuffer[];
double PlusDiBuffer[];
double MinusDiBuffer[];
double PlusSdiBuffer[];
double MinusSdiBuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(6);
//---- indicator buffers
   SetIndexBuffer(0,ADXBuffer);
   SetIndexBuffer(1,PlusDiBuffer);
   SetIndexBuffer(2,MinusDiBuffer);
   SetIndexBuffer(3,PlusSdiBuffer);
   SetIndexBuffer(4,MinusSdiBuffer);
   SetIndexBuffer(5,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("ADXmod("+ADXPeriod+","+DIplusPeriod+","+DIminusPeriod+","+Price+")");
   SetIndexLabel(0,"ADX");
   SetIndexLabel(1,"+DI");
   SetIndexLabel(2,"-DI");
//----
   SetIndexDrawBegin(0,ADXPeriod);
   SetIndexDrawBegin(1,ADXPeriod);
   SetIndexDrawBegin(2,ADXPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average Directional Movement Index                               |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
//----
   if ( counted_bars > 0 )  int limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-ADXPeriod-1; 
      
	for(int shift=limit;shift>=0;shift--) 
   {
   PlusSdiBuffer[shift]= iADX(NULL,0, DIplusPeriod,Price,MODE_PLUSDI ,shift);
   MinusSdiBuffer[shift]=iADX(NULL,0,DIminusPeriod,Price,MODE_MINUSDI,shift);
   TempBuffer[shift]= iADX(NULL,0,ADXPeriod,Price,MODE_MAIN,shift) ;
   }
   for(shift=limit;shift>=0;shift--) 
   {		
//---- 
   PlusDiBuffer[shift]=iMAOnArray(PlusSdiBuffer,Bars,DIplusSmooth,0,MAType,shift);
   MinusDiBuffer[shift]=iMAOnArray(MinusSdiBuffer,Bars,DIminusSmooth,0,MAType,shift);
   ADXBuffer[shift]=iMAOnArray(TempBuffer,Bars,ADXSmooth,0,MAType,shift);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+